#include "/prelude/core.glsl"

out gl_PerVertex {
	vec4 gl_Position;
};

uniform mat4 modelViewMatrix, projectionMatrix, textureMatrix;

in vec2 vaUV0;
in vec3 vaPosition;

out VertexData { layout(location = 0) vec2 coord; } v;

#include "/lib/mmul.glsl"

void main() {
	gl_Position = proj_mmul(projectionMatrix, rot_trans_mmul(modelViewMatrix, vaPosition));

	v.coord = rot_trans_mmul(textureMatrix, vaUV0);
}