#include "/prelude/core.glsl"

const ivec3 workGroups = ivec3(1, 1, 1);
layout(local_size_x = 1, local_size_y = 1, local_size_z = 1) in;

writeonly
#include "/buf/indirect/dispatch.glsl"

writeonly
#include "/buf/index.glsl"

#if DCG_EXP || DCG_COLOR || DCG_BP
	writeonly
	#include "/buf/dcg.glsl"
#endif

#if HAND_LIGHT
	writeonly
	#include "/buf/hand_light.glsl"
#endif

void main() {
	indirect_dispatch.work_groups = uvec3(0u, 1u, 1u);

	#if DCG_EXP || DCG_COLOR || DCG_BP
		dcg.max_color = vec3(1.0);
		dcg.min_val = 0.0;
		dcg.max_luma = 1.0;
	#endif

	index.queue = 0u;
	index.len = uint16_t(0u);

	#if HAND_LIGHT
		hand_light.data = uvec4(0u);
	#endif
}